/* Problem URL: https://codeforces.com/contest/2167/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, k;
    ll x;
    cin >> n >> k >> x;

    vl a(n);
    cin >> a;

    sortv(a);
    a.erase(unique(all(a)), a.end());

    if (x - a.size() + 1 < k) {
        rep(i, k) {
            cout << i << ' ';
        }
        cout << '\n';
        return;
    }

    priority_queue<tuple<ll, ll, ll, ll, ll, int>> pq;
    if (a[0] != 0) {
        pq.emplace(a[0], 0, 0, -1e9, a[0], -1);
    }
    if (a.back() != x) {
        pq.emplace(x - a.back(), x, x, a.back(), 2e9, -2);
    }

    nrep(i, 1, a.size()) {
        if (a[i] == a[i - 1] - 1) {
            continue;
        }

        ll med = (a[i] + a[i - 1]) >> 1;
        ll dis = min(a[i] - med, med - a[i - 1]);

        pq.emplace(dis, med, med, a[i - 1], a[i], i);
    }

    set<tuple<int, ll, ll>> ranges;
    while (k--) {
        auto [d, l, r, lim1, lim2, id] = pq.top();
        pq.pop();

        if (l < 0 || l <= lim1 || r >= lim2 || r > x) {
            k++;
            continue;
        }

        auto itr = ranges.lower_bound({id, -1, -1});
        if (itr != ranges.end() && get<0>(*itr) == id) {
            ranges.erase(itr);
        }

        ranges.emplace(id, l, r);

        ll l1 = l - 1;
        ll r1 = r;
        ll l2 = l;
        ll r2 = r + 1;
        ll dis1 = min(l1 - lim1, lim2 - r1);
        ll dis2 = min(l2 - lim1, lim2 - r2);

        if (l1 < max(0LL, lim1 + 1) || r1 > min(x, lim2 - 1)) {
            dis1 = -1;
        }
        if (l2 < max(0LL, lim1 + 1) || r2 > min(x, lim2 - 1)) {
            dis2 = -1;
        }

        if (dis1 >= dis2) {
            pq.emplace(dis1, l1, r1, lim1, lim2, id);
            continue;
        }
        pq.emplace(dis2, l2, r2, lim1, lim2, id);
    }

    repv(i, ranges) {
        auto [id, lim1, lim2] = i;
        nrep(j, lim1, lim2 + 1) {
            cout << j << ' ';
        }
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
